/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
!function(t,n){"object"==typeof exports&&"undefined"!=typeof module?n(exports,require("@angular/material/core"),require("@material/ripple"),require("@angular/cdk/platform"),require("@angular/core"),require("@angular/platform-browser/animations"),require("@angular/common")):"function"==typeof define&&define.amd?define("@angular/material-experimental/mdc-button",["exports","@angular/material/core","@material/ripple","@angular/cdk/platform","@angular/core","@angular/platform-browser/animations","@angular/common"],n):n((t.ng=t.ng||{},t.ng.materialExperimental=t.ng.materialExperimental||{},t.ng.materialExperimental.mdcButton={}),t.ng.material.core,t.mdc.ripple,t.ng.cdk.platform,t.ng.core,t.ng.platformBrowser.animations,t.ng.common)}(this,function(t,n,e,o,i,a,c){"use strict";function r(t,n){function e(){this.constructor=t}d(t,n),t.prototype=null===n?Object.create(n):(e.prototype=n.prototype,new e)}var d=function(t,n){return(d=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(t,n){t.__proto__=n}||function(t,n){for(var e in n)n.hasOwnProperty(e)&&(t[e]=n[e])})(t,n)},m=function(){return m=Object.assign||function(t){for(var n,e=1,o=arguments.length;e<o;e++){n=arguments[e];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(t[i]=n[i])}return t},m.apply(this,arguments)},l=["disabled","disableRipple","color"],s={"[attr.disabled]":"disabled || null","[class._mat-animation-noopable]":'_animationMode === "NoopAnimations"'},b=[{selector:"mat-button",mdcClasses:["mdc-button","mat-mdc-button"]},{selector:"mat-flat-button",mdcClasses:["mdc-button","mdc-button--unelevated","mat-mdc-unelevated-button"]},{selector:"mat-raised-button",mdcClasses:["mdc-button","mdc-button--raised","mat-mdc-raised-button"]},{selector:"mat-stroked-button",mdcClasses:["mdc-button","mdc-button--outlined","mat-mdc-outlined-button"]},{selector:"mat-fab",mdcClasses:["mdc-fab","mat-mdc-fab"]},{selector:"mat-mini-fab",mdcClasses:["mdc-fab","mdc-fab--mini","mat-mdc-mini-fab"]},{selector:"mat-icon-button",mdcClasses:["mdc-icon-button","mat-mdc-icon-button"]}],u=function(){function t(t){this._elementRef=t}return t}(),p=n.mixinColor(n.mixinDisabled(n.mixinDisableRipple(u))),_=function(t){function n(n,o,i,a){var c,r=t.call(this,n)||this;r._platform=o,r._ngZone=i,r._animationMode=a,r._rippleAnimation={enterDuration:e.numbers.DEACTIVATION_TIMEOUT_MS,exitDuration:e.numbers.FG_DEACTIVATION_MS},r._isRippleCentered=!1;for(var d=0,m=b;d<m.length;d++){var l=m[d];r._hasHostAttributes(l.selector)&&(c=n.nativeElement.classList).add.apply(c,l.mdcClasses)}return r}return r(n,t),n.prototype.focus=function(){this._elementRef.nativeElement.focus()},n.prototype._hasHostAttributes=function(){for(var t=this,n=[],e=0;e<arguments.length;e++)n[e]=arguments[e];return n.some(function(n){return t._elementRef.nativeElement.hasAttribute(n)})},n.prototype._isRippleDisabled=function(){return this.disableRipple||this.disabled},n}(p),f=["disabled","disableRipple","color","tabIndex"],g=m({},s,{"[attr.tabindex]":"disabled ? -1 : (tabIndex || 0)","[attr.aria-disabled]":"disabled.toString()","(click)":"_haltDisabledEvents($event)"}),x=function(t){function n(n,e,o,i){return t.call(this,n,e,o,i)||this}return r(n,t),n.prototype._haltDisabledEvents=function(t){this.disabled&&(t.preventDefault(),t.stopImmediatePropagation())},n}(_),h=function(t){function n(n,e,o,i){return t.call(this,n,e,o,i)||this}return r(n,t),n.decorators=[{type:i.Component,args:[{selector:"\n    button[mat-button], button[mat-raised-button], button[mat-flat-button],\n    button[mat-stroked-button]\n  ",template:'<ng-content select=".material-icons:not([iconPositionEnd]), mat-icon:not([iconPositionEnd])"></ng-content><span class="mdc-button__label"><ng-content></ng-content></span><ng-content select=".material-icons[iconPositionEnd], mat-icon[iconPositionEnd]"></ng-content><div matRipple class="mat-button-ripple" [matRippleAnimation]="_rippleAnimation" [matRippleDisabled]="_isRippleDisabled()" [matRippleCentered]="_isRippleCentered" [matRippleTrigger]="_elementRef.nativeElement"></div>',styles:[".mdc-button{padding:0 8px 0 8px;display:inline-flex;position:relative;align-items:center;justify-content:center;box-sizing:border-box;min-width:64px;height:36px;border:none;outline:0;line-height:inherit;user-select:none;-webkit-appearance:none;vertical-align:middle;border-radius:4px}.mdc-button::-moz-focus-inner{padding:0;border:0}.mdc-button:active{outline:0}.mdc-button:hover{cursor:pointer}.mdc-button:disabled{cursor:default;pointer-events:none}.mdc-button .mdc-button__ripple{border-radius:4px}.mdc-button.mdc-button--dense{border-radius:4px}.mdc-button .mdc-button__icon{margin-left:0;margin-right:8px;display:inline-block;width:18px;height:18px;font-size:18px;vertical-align:top}.mdc-button .mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button .mdc-button__icon{margin-left:8px;margin-right:0}.mdc-button .mdc-button__touch{position:absolute;top:50%;right:0;left:0;height:48px;transform:translateY(-50%)}.mdc-button__label+.mdc-button__icon{margin-left:8px;margin-right:0}.mdc-button__label+.mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button__label+.mdc-button__icon{margin-left:0;margin-right:8px}svg.mdc-button__icon{fill:currentColor}.mdc-button--outlined .mdc-button__icon,.mdc-button--raised .mdc-button__icon,.mdc-button--unelevated .mdc-button__icon{margin-left:-4px;margin-right:8px}.mdc-button--outlined .mdc-button__icon[dir=rtl],.mdc-button--raised .mdc-button__icon[dir=rtl],.mdc-button--unelevated .mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--outlined .mdc-button__icon,[dir=rtl] .mdc-button--raised .mdc-button__icon,[dir=rtl] .mdc-button--unelevated .mdc-button__icon{margin-left:8px;margin-right:-4px}.mdc-button--outlined .mdc-button__label+.mdc-button__icon,.mdc-button--raised .mdc-button__label+.mdc-button__icon,.mdc-button--unelevated .mdc-button__label+.mdc-button__icon{margin-left:8px;margin-right:-4px}.mdc-button--outlined .mdc-button__label+.mdc-button__icon[dir=rtl],.mdc-button--raised .mdc-button__label+.mdc-button__icon[dir=rtl],.mdc-button--unelevated .mdc-button__label+.mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--outlined .mdc-button__label+.mdc-button__icon,[dir=rtl] .mdc-button--raised .mdc-button__label+.mdc-button__icon,[dir=rtl] .mdc-button--unelevated .mdc-button__label+.mdc-button__icon{margin-left:-4px;margin-right:8px}.mdc-button--raised,.mdc-button--unelevated{padding:0 16px 0 16px}.mdc-button--raised{transition:box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mdc-button--outlined{border-style:solid;padding:0 15px 0 15px;border-width:1px}.mdc-button--outlined .mdc-button__ripple{top:-1px;left:-1px;border:1px solid transparent}.mdc-button--dense{height:32px;font-size:.8125rem}.mdc-button--touch{margin:6px 0}@media (-ms-high-contrast:active){.mat-mdc-button:not(.mdc-button--outlined),.mat-mdc-outlined-button:not(.mdc-button--outlined),.mat-mdc-raised-button:not(.mdc-button--outlined),.mat-mdc-unelevated-button:not(.mdc-button--outlined){outline:solid 1px}}"],inputs:l,host:s,exportAs:"matButton",encapsulation:i.ViewEncapsulation.None,changeDetection:i.ChangeDetectionStrategy.OnPush}]}],n.ctorParameters=function(){return[{type:i.ElementRef},{type:o.Platform},{type:i.NgZone},{type:String,decorators:[{type:i.Optional},{type:i.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},n}(_),y=function(t){function n(n,e,o,i){return t.call(this,n,e,o,i)||this}return r(n,t),n.decorators=[{type:i.Component,args:[{selector:"a[mat-button], a[mat-raised-button], a[mat-flat-button], a[mat-stroked-button]",exportAs:"matButton, matAnchor",host:g,inputs:f,template:'<ng-content select=".material-icons:not([iconPositionEnd]), mat-icon:not([iconPositionEnd])"></ng-content><span class="mdc-button__label"><ng-content></ng-content></span><ng-content select=".material-icons[iconPositionEnd], mat-icon[iconPositionEnd]"></ng-content><div matRipple class="mat-button-ripple" [matRippleAnimation]="_rippleAnimation" [matRippleDisabled]="_isRippleDisabled()" [matRippleCentered]="_isRippleCentered" [matRippleTrigger]="_elementRef.nativeElement"></div>',styles:[".mdc-button{padding:0 8px 0 8px;display:inline-flex;position:relative;align-items:center;justify-content:center;box-sizing:border-box;min-width:64px;height:36px;border:none;outline:0;line-height:inherit;user-select:none;-webkit-appearance:none;vertical-align:middle;border-radius:4px}.mdc-button::-moz-focus-inner{padding:0;border:0}.mdc-button:active{outline:0}.mdc-button:hover{cursor:pointer}.mdc-button:disabled{cursor:default;pointer-events:none}.mdc-button .mdc-button__ripple{border-radius:4px}.mdc-button.mdc-button--dense{border-radius:4px}.mdc-button .mdc-button__icon{margin-left:0;margin-right:8px;display:inline-block;width:18px;height:18px;font-size:18px;vertical-align:top}.mdc-button .mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button .mdc-button__icon{margin-left:8px;margin-right:0}.mdc-button .mdc-button__touch{position:absolute;top:50%;right:0;left:0;height:48px;transform:translateY(-50%)}.mdc-button__label+.mdc-button__icon{margin-left:8px;margin-right:0}.mdc-button__label+.mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button__label+.mdc-button__icon{margin-left:0;margin-right:8px}svg.mdc-button__icon{fill:currentColor}.mdc-button--outlined .mdc-button__icon,.mdc-button--raised .mdc-button__icon,.mdc-button--unelevated .mdc-button__icon{margin-left:-4px;margin-right:8px}.mdc-button--outlined .mdc-button__icon[dir=rtl],.mdc-button--raised .mdc-button__icon[dir=rtl],.mdc-button--unelevated .mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--outlined .mdc-button__icon,[dir=rtl] .mdc-button--raised .mdc-button__icon,[dir=rtl] .mdc-button--unelevated .mdc-button__icon{margin-left:8px;margin-right:-4px}.mdc-button--outlined .mdc-button__label+.mdc-button__icon,.mdc-button--raised .mdc-button__label+.mdc-button__icon,.mdc-button--unelevated .mdc-button__label+.mdc-button__icon{margin-left:8px;margin-right:-4px}.mdc-button--outlined .mdc-button__label+.mdc-button__icon[dir=rtl],.mdc-button--raised .mdc-button__label+.mdc-button__icon[dir=rtl],.mdc-button--unelevated .mdc-button__label+.mdc-button__icon[dir=rtl],[dir=rtl] .mdc-button--outlined .mdc-button__label+.mdc-button__icon,[dir=rtl] .mdc-button--raised .mdc-button__label+.mdc-button__icon,[dir=rtl] .mdc-button--unelevated .mdc-button__label+.mdc-button__icon{margin-left:-4px;margin-right:8px}.mdc-button--raised,.mdc-button--unelevated{padding:0 16px 0 16px}.mdc-button--raised{transition:box-shadow 280ms cubic-bezier(.4,0,.2,1)}.mdc-button--outlined{border-style:solid;padding:0 15px 0 15px;border-width:1px}.mdc-button--outlined .mdc-button__ripple{top:-1px;left:-1px;border:1px solid transparent}.mdc-button--dense{height:32px;font-size:.8125rem}.mdc-button--touch{margin:6px 0}@media (-ms-high-contrast:active){.mat-mdc-button:not(.mdc-button--outlined),.mat-mdc-outlined-button:not(.mdc-button--outlined),.mat-mdc-raised-button:not(.mdc-button--outlined),.mat-mdc-unelevated-button:not(.mdc-button--outlined){outline:solid 1px}}"],encapsulation:i.ViewEncapsulation.None,changeDetection:i.ChangeDetectionStrategy.OnPush}]}],n.ctorParameters=function(){return[{type:i.ElementRef},{type:o.Platform},{type:i.NgZone},{type:String,decorators:[{type:i.Optional},{type:i.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},n}(x),v=function(t){function n(n,e,o,i){return t.call(this,n,e,o,i)||this}return r(n,t),n.decorators=[{type:i.Component,args:[{selector:"button[mat-fab], button[mat-mini-fab]",template:'<ng-content select=".material-icons:not([iconPositionEnd]), mat-icon:not([iconPositionEnd])"></ng-content><span class="mdc-button__label"><ng-content></ng-content></span><ng-content select=".material-icons[iconPositionEnd], mat-icon[iconPositionEnd]"></ng-content><div matRipple class="mat-button-ripple" [matRippleAnimation]="_rippleAnimation" [matRippleDisabled]="_isRippleDisabled()" [matRippleCentered]="_isRippleCentered" [matRippleTrigger]="_elementRef.nativeElement"></div>',styles:[".mdc-fab{display:inline-flex;position:relative;align-items:center;justify-content:center;box-sizing:border-box;width:56px;height:56px;padding:0;border:none;fill:currentColor;text-decoration:none;cursor:pointer;user-select:none;-moz-appearance:none;-webkit-appearance:none;overflow:hidden;transition:box-shadow 280ms cubic-bezier(.4,0,.2,1),opacity 15ms linear 30ms,transform 270ms 0s cubic-bezier(0,0,.2,1)}.mdc-fab:not(.mdc-fab--extended){border-radius:50%}.mdc-fab::-moz-focus-inner{padding:0;border:0}.mdc-fab:active,.mdc-fab:focus{outline:0}.mdc-fab:hover{cursor:pointer}.mdc-fab>svg{width:100%}.mdc-fab .mat-icon,.mdc-fab .mdc-fab__icon{width:24px;height:24px;font-size:24px}.mdc-fab--mini{width:40px;height:40px}.mdc-fab--extended{border-radius:24px;padding:0 20px;width:auto;max-width:100%;height:48px}.mdc-fab--extended .mat-icon,.mdc-fab--extended .mdc-fab__icon{margin-left:-8px;margin-right:12px}.mdc-fab--extended .mat-icon[dir=rtl],.mdc-fab--extended .mdc-fab__icon[dir=rtl],[dir=rtl] .mdc-fab--extended .mat-icon,[dir=rtl] .mdc-fab--extended .mdc-fab__icon{margin-left:12px;margin-right:-8px}.mdc-fab--extended .mdc-fab__label+.mat-icon,.mdc-fab--extended .mdc-fab__label+.mdc-fab__icon{margin-left:12px;margin-right:-8px}.mdc-fab--extended .mdc-fab__label+.mat-icon[dir=rtl],.mdc-fab--extended .mdc-fab__label+.mdc-fab__icon[dir=rtl],[dir=rtl] .mdc-fab--extended .mdc-fab__label+.mat-icon,[dir=rtl] .mdc-fab--extended .mdc-fab__label+.mdc-fab__icon{margin-left:-8px;margin-right:12px}.mdc-fab__label{justify-content:flex-start;text-overflow:ellipsis;white-space:nowrap;overflow:hidden}.mat-icon,.mdc-fab__icon{transition:transform 180ms 90ms cubic-bezier(0,0,.2,1);fill:currentColor;will-change:transform}.mdc-fab .mat-icon,.mdc-fab .mdc-fab__icon{display:inline-flex;align-items:center;justify-content:center}.mdc-fab--exited{transform:scale(0);opacity:0;transition:opacity 15ms linear 150ms,transform 180ms 0s cubic-bezier(.4,0,1,1)}.mdc-fab--exited .mat-icon,.mdc-fab--exited .mdc-fab__icon{transform:scale(0);transition:transform 135ms 0s cubic-bezier(.4,0,1,1)}"],inputs:l,host:s,exportAs:"matButton",encapsulation:i.ViewEncapsulation.None,changeDetection:i.ChangeDetectionStrategy.OnPush}]}],n.ctorParameters=function(){return[{type:i.ElementRef},{type:o.Platform},{type:i.NgZone},{type:String,decorators:[{type:i.Optional},{type:i.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},n}(_),R=function(t){function n(n,e,o,i){return t.call(this,n,e,o,i)||this}return r(n,t),n.decorators=[{type:i.Component,args:[{selector:"a[mat-fab], a[mat-mini-fab]",template:'<ng-content select=".material-icons:not([iconPositionEnd]), mat-icon:not([iconPositionEnd])"></ng-content><span class="mdc-button__label"><ng-content></ng-content></span><ng-content select=".material-icons[iconPositionEnd], mat-icon[iconPositionEnd]"></ng-content><div matRipple class="mat-button-ripple" [matRippleAnimation]="_rippleAnimation" [matRippleDisabled]="_isRippleDisabled()" [matRippleCentered]="_isRippleCentered" [matRippleTrigger]="_elementRef.nativeElement"></div>',styles:[".mdc-fab{display:inline-flex;position:relative;align-items:center;justify-content:center;box-sizing:border-box;width:56px;height:56px;padding:0;border:none;fill:currentColor;text-decoration:none;cursor:pointer;user-select:none;-moz-appearance:none;-webkit-appearance:none;overflow:hidden;transition:box-shadow 280ms cubic-bezier(.4,0,.2,1),opacity 15ms linear 30ms,transform 270ms 0s cubic-bezier(0,0,.2,1)}.mdc-fab:not(.mdc-fab--extended){border-radius:50%}.mdc-fab::-moz-focus-inner{padding:0;border:0}.mdc-fab:active,.mdc-fab:focus{outline:0}.mdc-fab:hover{cursor:pointer}.mdc-fab>svg{width:100%}.mdc-fab .mat-icon,.mdc-fab .mdc-fab__icon{width:24px;height:24px;font-size:24px}.mdc-fab--mini{width:40px;height:40px}.mdc-fab--extended{border-radius:24px;padding:0 20px;width:auto;max-width:100%;height:48px}.mdc-fab--extended .mat-icon,.mdc-fab--extended .mdc-fab__icon{margin-left:-8px;margin-right:12px}.mdc-fab--extended .mat-icon[dir=rtl],.mdc-fab--extended .mdc-fab__icon[dir=rtl],[dir=rtl] .mdc-fab--extended .mat-icon,[dir=rtl] .mdc-fab--extended .mdc-fab__icon{margin-left:12px;margin-right:-8px}.mdc-fab--extended .mdc-fab__label+.mat-icon,.mdc-fab--extended .mdc-fab__label+.mdc-fab__icon{margin-left:12px;margin-right:-8px}.mdc-fab--extended .mdc-fab__label+.mat-icon[dir=rtl],.mdc-fab--extended .mdc-fab__label+.mdc-fab__icon[dir=rtl],[dir=rtl] .mdc-fab--extended .mdc-fab__label+.mat-icon,[dir=rtl] .mdc-fab--extended .mdc-fab__label+.mdc-fab__icon{margin-left:-8px;margin-right:12px}.mdc-fab__label{justify-content:flex-start;text-overflow:ellipsis;white-space:nowrap;overflow:hidden}.mat-icon,.mdc-fab__icon{transition:transform 180ms 90ms cubic-bezier(0,0,.2,1);fill:currentColor;will-change:transform}.mdc-fab .mat-icon,.mdc-fab .mdc-fab__icon{display:inline-flex;align-items:center;justify-content:center}.mdc-fab--exited{transform:scale(0);opacity:0;transition:opacity 15ms linear 150ms,transform 180ms 0s cubic-bezier(.4,0,1,1)}.mdc-fab--exited .mat-icon,.mdc-fab--exited .mdc-fab__icon{transform:scale(0);transition:transform 135ms 0s cubic-bezier(.4,0,1,1)}"],inputs:f,host:g,exportAs:"matButton, matAnchor",encapsulation:i.ViewEncapsulation.None,changeDetection:i.ChangeDetectionStrategy.OnPush}]}],n.ctorParameters=function(){return[{type:i.ElementRef},{type:o.Platform},{type:i.NgZone},{type:String,decorators:[{type:i.Optional},{type:i.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},n}(y),E=function(t){function n(n,e,o,i){var a=t.call(this,n,e,o,i)||this;return a._isRippleCentered=!0,a}return r(n,t),n.decorators=[{type:i.Component,args:[{selector:"button[mat-icon-button]",template:'<ng-content select=".material-icons:not([iconPositionEnd]), mat-icon:not([iconPositionEnd])"></ng-content><span class="mdc-button__label"><ng-content></ng-content></span><ng-content select=".material-icons[iconPositionEnd], mat-icon[iconPositionEnd]"></ng-content><div matRipple class="mat-button-ripple" [matRippleAnimation]="_rippleAnimation" [matRippleDisabled]="_isRippleDisabled()" [matRippleCentered]="_isRippleCentered" [matRippleTrigger]="_elementRef.nativeElement"></div>',styles:[".mdc-icon-button{width:48px;height:48px;padding:12px;font-size:24px;display:inline-block;position:relative;box-sizing:border-box;border:none;outline:0;background-color:transparent;fill:currentColor;color:inherit;text-decoration:none;cursor:pointer;user-select:none}.mdc-icon-button img,.mdc-icon-button svg{width:24px;height:24px}.mdc-icon-button:disabled{cursor:default;pointer-events:none}.mdc-icon-button__icon{display:inline-block}.mdc-icon-button__icon.mdc-icon-button__icon--on{display:none}.mdc-icon-button--on .mdc-icon-button__icon{display:none}.mdc-icon-button--on .mdc-icon-button__icon.mdc-icon-button__icon--on{display:inline-block}.mat-mdc-icon-button{border-radius:50%}"],inputs:l,host:s,exportAs:"matButton",encapsulation:i.ViewEncapsulation.None,changeDetection:i.ChangeDetectionStrategy.OnPush}]}],n.ctorParameters=function(){return[{type:i.ElementRef},{type:o.Platform},{type:i.NgZone},{type:String,decorators:[{type:i.Optional},{type:i.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},n}(_),w=function(t){function n(n,e,o,i){var a=t.call(this,n,e,o,i)||this;return a._isRippleCentered=!0,a}return r(n,t),n.decorators=[{type:i.Component,args:[{selector:"a[mat-icon-button]",template:'<ng-content select=".material-icons:not([iconPositionEnd]), mat-icon:not([iconPositionEnd])"></ng-content><span class="mdc-button__label"><ng-content></ng-content></span><ng-content select=".material-icons[iconPositionEnd], mat-icon[iconPositionEnd]"></ng-content><div matRipple class="mat-button-ripple" [matRippleAnimation]="_rippleAnimation" [matRippleDisabled]="_isRippleDisabled()" [matRippleCentered]="_isRippleCentered" [matRippleTrigger]="_elementRef.nativeElement"></div>',styles:[".mdc-icon-button{width:48px;height:48px;padding:12px;font-size:24px;display:inline-block;position:relative;box-sizing:border-box;border:none;outline:0;background-color:transparent;fill:currentColor;color:inherit;text-decoration:none;cursor:pointer;user-select:none}.mdc-icon-button img,.mdc-icon-button svg{width:24px;height:24px}.mdc-icon-button:disabled{cursor:default;pointer-events:none}.mdc-icon-button__icon{display:inline-block}.mdc-icon-button__icon.mdc-icon-button__icon--on{display:none}.mdc-icon-button--on .mdc-icon-button__icon{display:none}.mdc-icon-button--on .mdc-icon-button__icon.mdc-icon-button__icon--on{display:inline-block}.mat-mdc-icon-button{border-radius:50%}"],inputs:f,host:g,exportAs:"matButton, matAnchor",encapsulation:i.ViewEncapsulation.None,changeDetection:i.ChangeDetectionStrategy.OnPush}]}],n.ctorParameters=function(){return[{type:i.ElementRef},{type:o.Platform},{type:i.NgZone},{type:String,decorators:[{type:i.Optional},{type:i.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},n}(x),P=function(){function t(){}return t.decorators=[{type:i.NgModule,args:[{imports:[n.MatCommonModule,c.CommonModule,n.MatRippleModule],exports:[y,h,w,E,R,v,n.MatCommonModule],declarations:[y,h,w,E,R,v]}]}],t}();t.MatButton=h,t.MatAnchor=y,t.MatFabButton=v,t.MatFabAnchor=R,t.MatIconButton=E,t.MatIconAnchor=w,t.MatButtonModule=P,t.ɵg=g,t.ɵf=f,t.ɵb=s,t.ɵa=l,t.ɵh=x,t.ɵe=_,t.ɵc=u,t.ɵd=p,Object.defineProperty(t,"__esModule",{value:!0})});
//# sourceMappingURL=material-experimental-mdc-button.umd.min.js.map
