/**
 * @license
 * Copyright Google LLC All Rights Reserved.
 *
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://angular.io/license
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("@angular/core"),require("@material/switch"),require("@angular/forms"),require("@angular/cdk/coercion"),require("@angular/platform-browser/animations"),require("@angular/common"),require("@angular/material/core"),require("@angular/material/slide-toggle")):"function"==typeof define&&define.amd?define("@angular/material-experimental/mdc-slide-toggle",["exports","@angular/core","@material/switch","@angular/forms","@angular/cdk/coercion","@angular/platform-browser/animations","@angular/common","@angular/material/core","@angular/material/slide-toggle"],t):t((e.ng=e.ng||{},e.ng.materialExperimental=e.ng.materialExperimental||{},e.ng.materialExperimental.mdcSlideToggle={}),e.ng.core,e.mdc.switch,e.ng.forms,e.ng.cdk.coercion,e.ng.platformBrowser.animations,e.ng.common,e.ng.material.core,e.ng.material.slideToggle)}(this,function(e,t,i,n,o,a,r,c,l){"use strict";var d=new t.InjectionToken("mat-slide-toggle-default-options",{providedIn:"root",factory:function(){return{disableToggleValue:!1,disableDragValue:!1}}}),s=0,u={provide:n.NG_VALUE_ACCESSOR,useExisting:t.forwardRef(function(){return m}),multi:!0},h=function(){function e(e,t){this.source=e,this.checked=t}return e}(),m=function(){function e(e,i,n,o){var a=this;this._changeDetectorRef=e,this.defaults=n,this._animationMode=o,this._onChange=function(e){},this._onTouched=function(){},this._uniqueId="mat-slide-toggle-"+ ++s,this._required=!1,this._checked=!1,this._adapter={addClass:function(e){a._toggleClass(e,!0)},removeClass:function(e){a._toggleClass(e,!1)},setNativeControlChecked:function(e){a._checked=e},setNativeControlDisabled:function(e){a._disabled=e}},this._classes={"mdc-switch":!0},this._rippleAnimation={enterDuration:225,exitDuration:150},this.color="accent",this.name=null,this.id=this._uniqueId,this.labelPosition="after",this.ariaLabel=null,this.ariaLabelledby=null,this._disableRipple=!1,this._disabled=!1,this.change=new t.EventEmitter,this.toggleChange=new t.EventEmitter,this.dragChange=new t.EventEmitter,this.tabIndex=parseInt(i)||0}return Object.defineProperty(e.prototype,"tabIndex",{get:function(){return this._tabIndex},set:function(e){this._tabIndex=o.coerceNumberProperty(e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"required",{get:function(){return this._required},set:function(e){this._required=o.coerceBooleanProperty(e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"checked",{get:function(){return this._checked},set:function(e){this._checked=o.coerceBooleanProperty(e),this._foundation&&this._foundation.setChecked(this._checked)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"disableRipple",{get:function(){return this._disableRipple},set:function(e){this._disableRipple=o.coerceBooleanProperty(e)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"disabled",{get:function(){return this._disabled},set:function(e){this._disabled=o.coerceBooleanProperty(e),this._foundation&&this._foundation.setDisabled(this._disabled)},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"inputId",{get:function(){return(this.id||this._uniqueId)+"-input"},enumerable:!0,configurable:!0}),e.prototype.ngAfterViewInit=function(){var e=this._foundation=new i.MDCSwitchFoundation(this._adapter);e.setDisabled(this.disabled),e.setChecked(this.checked)},e.prototype.ngOnDestroy=function(){this._foundation&&this._foundation.destroy()},e.prototype._onChangeEvent=function(e){if(e.stopPropagation(),this.toggleChange.emit(),this._foundation.handleChange(e),this.defaults.disableToggleValue)return void(this._inputElement.nativeElement.checked=this.checked);this.checked=this._inputElement.nativeElement.checked,this._onChange(this.checked),this.change.emit(new h(this,this.checked))},e.prototype._onInputClick=function(e){e.stopPropagation()},e.prototype.writeValue=function(e){this.checked=!!e,this._changeDetectorRef.markForCheck()},e.prototype.registerOnChange=function(e){this._onChange=e},e.prototype.registerOnTouched=function(e){this._onTouched=e},e.prototype.setDisabledState=function(e){this.disabled=e,this._changeDetectorRef.markForCheck()},e.prototype.focus=function(){this._inputElement.nativeElement.focus()},e.prototype.toggle=function(){this.checked=!this.checked,this._onChange(this.checked)},e.prototype._onBlur=function(){var e=this;Promise.resolve().then(function(){e._focused=!1,e._onTouched(),e._changeDetectorRef.markForCheck()})},e.prototype._toggleClass=function(e,t){this._classes[e]=t,this._changeDetectorRef.markForCheck()},e.decorators=[{type:t.Component,args:[{selector:"mat-slide-toggle",template:'<div class="mdc-form-field" [class.mdc-form-field--align-end]="labelPosition == \'before\'"><div [ngClass]="_classes" #switch><div class="mdc-switch__track"></div><div class="mdc-switch__thumb-underlay"><div class="mat-mdc-slide-toggle-ripple" mat-ripple [matRippleTrigger]="switch" [matRippleDisabled]="disableRipple || disabled" [matRippleCentered]="true" [matRippleRadius]="24" [matRippleAnimation]="_rippleAnimation"></div><div class="mdc-switch__thumb"><input #input class="mdc-switch__native-control" type="checkbox" role="switch" [id]="inputId" [required]="required" [tabIndex]="tabIndex" [checked]="checked" [disabled]="disabled" [attr.name]="name" [attr.aria-checked]="checked.toString()" [attr.aria-label]="ariaLabel" [attr.aria-labelledby]="ariaLabelledby" (change)="_onChangeEvent($event)" (click)="_onInputClick($event)" (blur)="_onBlur()" (focus)="_focused = true"></div></div></div><label #label [for]="inputId" (click)="$event.stopPropagation()"><ng-content></ng-content></label></div>',styles:[".mdc-switch{display:inline-block;position:relative;outline:0;user-select:none}.mdc-switch__native-control{left:0;right:initial;position:absolute;top:0;width:68px;height:48px;margin:0;opacity:0;cursor:pointer;pointer-events:auto}.mdc-switch__native-control[dir=rtl],[dir=rtl] .mdc-switch__native-control{left:initial;right:0}.mdc-switch__track{box-sizing:border-box;width:32px;height:14px;border:1px solid;border-radius:7px;opacity:.38;transition:opacity 90ms cubic-bezier(.4,0,.2,1),background-color 90ms cubic-bezier(.4,0,.2,1),border-color 90ms cubic-bezier(.4,0,.2,1)}.mdc-switch__thumb-underlay{left:-18px;right:initial;display:flex;position:absolute;top:-17px;align-items:center;justify-content:center;width:48px;height:48px;transform:translateX(0);transition:transform 90ms cubic-bezier(.4,0,.2,1),background-color 90ms cubic-bezier(.4,0,.2,1),border-color 90ms cubic-bezier(.4,0,.2,1)}.mdc-switch__thumb-underlay[dir=rtl],[dir=rtl] .mdc-switch__thumb-underlay{left:initial;right:-18px}.mdc-switch__thumb{box-sizing:border-box;width:20px;height:20px;border:10px solid;border-radius:50%;pointer-events:none;z-index:1}.mdc-switch--checked .mdc-switch__track{opacity:.54}.mdc-switch--checked .mdc-switch__thumb-underlay{transform:translateX(20px)}.mdc-switch--checked .mdc-switch__thumb-underlay[dir=rtl],[dir=rtl] .mdc-switch--checked .mdc-switch__thumb-underlay{transform:translateX(-20px)}.mdc-switch--checked .mdc-switch__native-control{transform:translateX(-20px)}.mdc-switch--checked .mdc-switch__native-control[dir=rtl],[dir=rtl] .mdc-switch--checked .mdc-switch__native-control{transform:translateX(20px)}.mdc-switch--disabled{opacity:.38;pointer-events:none}.mdc-switch--disabled .mdc-switch__thumb{border-width:1px}.mdc-switch--disabled .mdc-switch__native-control{cursor:default;pointer-events:none}.mdc-form-field{display:inline-flex;align-items:center;vertical-align:middle}.mdc-form-field>label{order:0;margin-right:auto;padding-left:4px}.mdc-form-field[dir=rtl]>label,[dir=rtl] .mdc-form-field>label{margin-left:auto;padding-right:4px}.mdc-form-field--align-end>label{order:-1;margin-left:auto;padding-right:4px}.mdc-form-field--align-end[dir=rtl]>label,[dir=rtl] .mdc-form-field--align-end>label{margin-right:auto;padding-left:4px}.mat-mdc-slide-toggle{display:inline-block}.mat-mdc-slide-toggle .mat-mdc-slide-toggle-ripple,.mat-mdc-slide-toggle .mdc-switch__thumb-underlay::before{top:0;left:0;right:0;bottom:0;position:absolute}.mat-mdc-slide-toggle .mdc-switch__thumb-underlay::before{border-radius:50%;content:'';opacity:0}.mat-mdc-slide-toggle .mdc-switch:hover .mdc-switch__thumb-underlay::before{opacity:.04;transition:mdc-switch-transition-enter(opacity,0,75ms)}.mat-mdc-slide-toggle.mat-mdc-slide-toggle-focused .mdc-switch .mdc-switch__thumb-underlay::before{opacity:.12}.mat-mdc-slide-toggle .mat-ripple-element{opacity:.12}.mat-mdc-slide-toggle._mat-animation-noopable .mdc-switch__thumb-underlay,.mat-mdc-slide-toggle._mat-animation-noopable .mdc-switch__thumb-underlay::before{transition:none}"],host:{class:"mat-mdc-slide-toggle","[id]":"id","[attr.tabindex]":"null","[class.mat-primary]":'color == "primary"',"[class.mat-accent]":'color == "accent"',"[class.mat-warn]":'color == "warn"',"[class.mat-mdc-slide-toggle-focused]":"_focused","[class.mat-mdc-slide-toggle-checked]":"checked","[class._mat-animation-noopable]":'_animationMode === "NoopAnimations"',"(focus)":"_inputElement.nativeElement.focus()"},exportAs:"matSlideToggle",encapsulation:t.ViewEncapsulation.None,changeDetection:t.ChangeDetectionStrategy.OnPush,providers:[u]}]}],e.ctorParameters=function(){return[{type:t.ChangeDetectorRef},{type:String,decorators:[{type:t.Attribute,args:["tabindex"]}]},{type:void 0,decorators:[{type:t.Inject,args:[d]}]},{type:String,decorators:[{type:t.Optional},{type:t.Inject,args:[a.ANIMATION_MODULE_TYPE]}]}]},e.propDecorators={color:[{type:t.Input}],name:[{type:t.Input}],id:[{type:t.Input}],tabIndex:[{type:t.Input}],labelPosition:[{type:t.Input}],ariaLabel:[{type:t.Input,args:["aria-label"]}],ariaLabelledby:[{type:t.Input,args:["aria-labelledby"]}],required:[{type:t.Input}],checked:[{type:t.Input}],disableRipple:[{type:t.Input}],disabled:[{type:t.Input}],change:[{type:t.Output}],toggleChange:[{type:t.Output}],dragChange:[{type:t.Output}],_inputElement:[{type:t.ViewChild,args:["input",{static:!1}]}]},e}(),p=function(){function e(){}return e.decorators=[{type:t.NgModule,args:[{imports:[l._MatSlideToggleRequiredValidatorModule,c.MatCommonModule,c.MatRippleModule,r.CommonModule],exports:[l._MatSlideToggleRequiredValidatorModule,m,c.MatCommonModule],declarations:[m]}]}],e}();e.MAT_SLIDE_TOGGLE_VALUE_ACCESSOR=u,e.MatSlideToggleChange=h,e.MatSlideToggle=m,e.MAT_SLIDE_TOGGLE_DEFAULT_OPTIONS=d,e.MatSlideToggleModule=p,Object.defineProperty(e,"__esModule",{value:!0})});
//# sourceMappingURL=material-experimental-mdc-slide-toggle.umd.min.js.map
